/**
 * Copyright (c) HashiCorp, Inc.
 * SPDX-License-Identifier: MPL-2.0
 */
import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataMongodbatlasMaintenanceWindowConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.36.0/docs/data-sources/maintenance_window#id DataMongodbatlasMaintenanceWindow#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.36.0/docs/data-sources/maintenance_window#project_id DataMongodbatlasMaintenanceWindow#project_id}
    */
    readonly projectId: string;
}
export interface DataMongodbatlasMaintenanceWindowProtectedHours {
}
export declare function dataMongodbatlasMaintenanceWindowProtectedHoursToTerraform(struct?: DataMongodbatlasMaintenanceWindowProtectedHours): any;
export declare function dataMongodbatlasMaintenanceWindowProtectedHoursToHclTerraform(struct?: DataMongodbatlasMaintenanceWindowProtectedHours): any;
export declare class DataMongodbatlasMaintenanceWindowProtectedHoursOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataMongodbatlasMaintenanceWindowProtectedHours | undefined;
    set internalValue(value: DataMongodbatlasMaintenanceWindowProtectedHours | undefined);
    get endHourOfDay(): number;
    get startHourOfDay(): number;
}
export declare class DataMongodbatlasMaintenanceWindowProtectedHoursList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataMongodbatlasMaintenanceWindowProtectedHoursOutputReference;
}
/**
* Represents a {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.36.0/docs/data-sources/maintenance_window mongodbatlas_maintenance_window}
*/
export declare class DataMongodbatlasMaintenanceWindow extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "mongodbatlas_maintenance_window";
    /**
    * Generates CDKTF code for importing a DataMongodbatlasMaintenanceWindow resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataMongodbatlasMaintenanceWindow to import
    * @param importFromId The id of the existing DataMongodbatlasMaintenanceWindow that should be imported. Refer to the {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.36.0/docs/data-sources/maintenance_window#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataMongodbatlasMaintenanceWindow to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.36.0/docs/data-sources/maintenance_window mongodbatlas_maintenance_window} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataMongodbatlasMaintenanceWindowConfig
    */
    constructor(scope: Construct, id: string, config: DataMongodbatlasMaintenanceWindowConfig);
    get autoDeferOnceEnabled(): cdktf.IResolvable;
    get dayOfWeek(): number;
    get hourOfDay(): number;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    get numberOfDeferrals(): number;
    private _projectId?;
    get projectId(): string;
    set projectId(value: string);
    get projectIdInput(): string | undefined;
    private _protectedHours;
    get protectedHours(): DataMongodbatlasMaintenanceWindowProtectedHoursList;
    get startAsap(): cdktf.IResolvable;
    get timeZoneId(): string;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
